__doc__ = """\
Project:OtherBases
Start:  Fri Aug 16 21:54:20 MSD 2002
Author: Andrey Orlov (c) 2002
Version $Id: HameleonBase.py,v 1.15 2002/11/24 20:26:33 cray Exp $

Title:   
        OtherBases / Hameleon

Description:

        Base class allow switching between acquised styles

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:   
        It's only alpha, have to debugged, refactored and enhanced.


"""
__version__ = '$Revision: 1.15 $'[11:-2]
# $Source: /var/lib/cvs/IIGFS/zope/Products/OtherBases/HameleonBase.py,v $

from Globals import default__class_init__
import Acquisition
from Acquisition import Acquired, aq_inner, aq_parent, aq_base, aq_self, aq_chain
from MOFS import l10n
_ = l10n.getL10n_decoder(__file__,'OtherBases')

import ZServer
ZServer.FTPRequest.FTPRequest


class HameleonBase (Acquisition.Implicit): #(ObjectManager.ObjectManager): #(Acquisition.Implicit) :
    """   """
        
    meta_type = 'HameleonBase' 

    def styles(self) :
        return (('',_('Not selected')),)+tuple(map(lambda x : (x.absolute_url(1),x.title_and_id()),self.superValues(['Folder'])))

    def __of__(self,ob) :
    
        #print type(ob.REQUEST),ob.REQUEST.__class__
        
        if not hasattr(ob,'REQUEST') or isinstance(ob.REQUEST,ZServer.FTPRequest.FTPRequest) :
            # print '    '
            return self.inheritedAttribute(HameleonBase,'__of__')(aq_base(self),ob)
            return self.inheritedAttribute(self.__class__,'__of__')(aq_base(self),ob)
        
        for item in aq_chain(ob) :
            try :
                if item._p_oid == self._p_oid :
                    return item
            except :
                pass
    
        try :
            style = aq_base(self).style 
        except (AttributeError,KeyError) :
            pass
        else :
            if style :
            
                try :
                    if style == 'default_style' :
                        style = self.default_style()
                    else :
                        style = ob.restrictedTraverse(style)
                except (KeyError,AttributeError,'NotFound') :
                    pass
                else :
                    style = style.aq_base.__of__(ob)
                    style = styleWrapper(ob).__of__(style)
                    ob = style.__of__(ob)


#        res = Acquisition.Implicit.__of__(aq_base(self),ob)
        return self.inheritedAttribute(HameleonBase,'__of__')(aq_base(self),ob)
#        return self.inheritedAttribute(self.__class__,'__of__')(aq_base(self),ob)

default__class_init__ (HameleonBase)

class styleWrapper(Acquisition.Implicit) :
    __allow_access_to_unprotected_subobjects__=1
    _is_style_wrapper = 1
    
    def __init__(self,parent) :
        #self._objects = parent._objects #    ,    
        self._parent = parent
        #self._getOb = parent._getOb
        #self.getPhysicalPath = parent.getPhysicalPath
        
    def getPhysicalPath(self) :
        return self._parent.getPhysicalPath()
        
    def _getOb(self,id) :
        return self._parent._getOb(id)

    def __getattr__notused(self,attr) :
        print attr
        #if attr == '_parent' :
        #    return 'AttributeError','_parent'
        if attr == 'objectIds' :
            print getattr(self._parent.aq_self,attr)()
        return getattr(self._parent.aq_self,attr)  
        
        